diff --git a/test/unit/tui/key_map_test.rb b/test/unit/tui/key_map_test.rb
index d58b283e..3311a849 100644
--- a/test/unit/tui/key_map_test.rb
+++ b/test/unit/tui/key_map_test.rb
@@ -155,11 +155,11 @@ class TuiKeyMapMessageForTest < Minitest::Test
     assert_same Hive::Tui::Messages::NOOP, msg
   end
 
-  def test_grid_i_with_row_returns_open_idea_preview
+  def test_grid_i_with_row_returns_open_task_info
     row = make_row(action_key: "ready_to_plan")
     msg = Hive::Tui::KeyMap.message_for(mode: :grid, key: "i", row: row)
 
-    assert_kind_of Hive::Tui::Messages::OpenIdeaPreview, msg
+    assert_kind_of Hive::Tui::Messages::OpenTaskInfo, msg
     assert_equal row, msg.row
   end
 
@@ -258,10 +258,15 @@ class TuiKeyMapMessageForTest < Minitest::Test
     assert_equal "i", msg.char
   end
 
-  def test_idea_preview_any_key_returns_back
-    [ "i", "x", :key_enter, :key_escape, "q", :space ].each do |key|
-      msg = Hive::Tui::KeyMap.message_for(mode: :idea_preview, key: key, row: nil)
-      assert_same Hive::Tui::Messages::BACK, msg, "#{key.inspect} must dismiss idea preview"
+  def test_task_info_only_q_escape_and_i_return_back
+    [ "i", :key_escape, "\e", "q" ].each do |key|
+      msg = Hive::Tui::KeyMap.message_for(mode: :task_info, key: key, row: nil)
+      assert_same Hive::Tui::Messages::BACK, msg, "#{key.inspect} must close task info"
+    end
+
+    [ "x", :key_enter, :key_up, :key_down, :key_tab, "/", "?", "b", "p", "d", "r", :space ].each do |key|
+      msg = Hive::Tui::KeyMap.message_for(mode: :task_info, key: key, row: nil)
+      assert_same Hive::Tui::Messages::NOOP, msg, "#{key.inspect} must be ignored in task info"
     end
   end
 
@@ -933,7 +938,7 @@ class TuiKeyMapMessageForTest < Minitest::Test
       [ :log_tail, "q",        make_row(action_key: "agent_running") ],
       [ :log_tail, :key_escape, make_row(action_key: "agent_running") ],
       [ :filter, :key_escape,  nil ],
-      [ :idea_preview, "x",    nil ]
+      [ :task_info, "x",       nil ]
     ]
 
     fixtures.each do |mode, key, row|
diff --git a/test/unit/tui/log_tail_test.rb b/test/unit/tui/log_tail_test.rb
index c0939a8b..f3f8b048 100644
--- a/test/unit/tui/log_tail_test.rb
+++ b/test/unit/tui/log_tail_test.rb
@@ -122,6 +122,21 @@ class TuiLogTailTest < Minitest::Test
     end
   end
 
+  def test_latest_accepts_a_narrow_filename_pattern
+    with_log_dir do |dir|
+      execute = File.join(dir, "execute-001.log")
+      review = File.join(dir, "review-001.log")
+      File.write(execute, "execute\n")
+      File.write(review, "review\n")
+      now = Time.now
+      File.utime(now - 10, now - 10, execute)
+      File.utime(now, now, review)
+
+      assert_equal review, Hive::Tui::LogTail::FileResolver.latest(dir)
+      assert_equal execute, Hive::Tui::LogTail::FileResolver.latest(dir, pattern: "execute-*.log")
+    end
+  end
+
   # The TOCTOU race between Dir[] glob and File.mtime on a rotating
   # log directory used to surface as Errno::ENOENT crashing the TUI.
   # Reproduce the race by overriding Dir.[] to return a path that no
diff --git a/test/unit/tui/messages_test.rb b/test/unit/tui/messages_test.rb
index 322dce55..0c797501 100644
--- a/test/unit/tui/messages_test.rb
+++ b/test/unit/tui/messages_test.rb
@@ -59,12 +59,18 @@ class HiveTuiMessagesTest < Minitest::Test
     assert_same row, msg.row
   end
 
-  def test_open_idea_preview_carries_row
+  def test_task_info_messages_carry_request_identity
     row = Object.new
-    msg = Hive::Tui::Messages::OpenIdeaPreview.new(row: row)
-
-    assert_same row, msg.row
-    assert_includes Hive::Tui::Messages::OpenIdeaPreview.members, :row
+    info = Object.new
+    open = Hive::Tui::Messages::OpenTaskInfo.new(row: row, request_id: "request-1")
+    loaded = Hive::Tui::Messages::TaskInfoLoaded.new(request_id: "request-1", info: info)
+    failed = Hive::Tui::Messages::TaskInfoFailed.new(request_id: "request-1", error: "unreadable")
+
+    assert_same row, open.row
+    assert_equal "request-1", open.request_id
+    assert_same info, loaded.info
+    assert_equal "request-1", loaded.request_id
+    assert_equal "unreadable", failed.error
   end
 
   def test_open_in_agent_carries_row
diff --git a/test/unit/tui/model_test.rb b/test/unit/tui/model_test.rb
index efcf5716..42dddc99 100644
--- a/test/unit/tui/model_test.rb
+++ b/test/unit/tui/model_test.rb
@@ -26,8 +26,7 @@ class HiveTuiModelTest < Minitest::Test
     assert_nil model.new_idea_staging_dir
     assert_nil model.new_idea_staging_tmp_root
     assert_equal [], model.new_idea_broken_labels
-    assert_nil model.idea_preview_text
-    assert_nil model.idea_preview_slug
+    assert_nil model.task_info_state
     assert_nil model.flash
     assert_nil model.flash_set_at
     assert_nil model.tail_state
@@ -65,15 +64,13 @@ class HiveTuiModelTest < Minitest::Test
     assert_equal 2, b.scope
   end
 
-  def test_with_updates_idea_preview_fields
-    a = Hive::Tui::Model.initial
-    b = a.with(idea_preview_text: "original idea", idea_preview_slug: "ship-preview")
+  def test_task_info_state_is_immutable_and_defaults_to_loading
+    state = Hive::Tui::Model::TaskInfoState.new(row: Object.new, request_id: "request-1")
 
-    assert_nil a.idea_preview_text
-    assert_nil a.idea_preview_slug
-    assert_equal "original idea", b.idea_preview_text
-    assert_equal "ship-preview", b.idea_preview_slug
-    refute_same a, b
+    assert_equal :loading, state.status
+    assert_nil state.info
+    assert_nil state.error
+    assert state.frozen?
   end
 
   def test_model_is_immutable
@@ -129,7 +126,7 @@ class HiveTuiModelTest < Minitest::Test
     expected = %i[mode snapshot cursor filter filter_buffer scope pane_focus new_idea_project_name
                   new_idea_project_cursor new_idea_buffer new_idea_cursor
                   new_idea_attachments new_idea_staging_dir new_idea_staging_tmp_root new_idea_attachment_counter
-                  new_idea_broken_labels idea_preview_text idea_preview_slug flash flash_set_at
+                  new_idea_broken_labels task_info_state flash flash_set_at
                   tail_state red_status_detail_state
                   cols rows last_error]
     assert_equal expected, Hive::Tui::Model.members
diff --git a/test/unit/tui/task_info_test.rb b/test/unit/tui/task_info_test.rb
new file mode 100644
index 00000000..b07f589c
--- /dev/null
+++ b/test/unit/tui/task_info_test.rb
@@ -0,0 +1,183 @@
+require "test_helper"
+require "digest"
+require "hive/tui/task_info"
+
+class HiveTuiTaskInfoTest < Minitest::Test
+  include HiveTestHelper
+
+  def create_task(root, stage:, slug: "ship-info")
+    folder = File.join(root, ".hive-state", "stages", stage, slug)
+    FileUtils.mkdir_p(folder)
+    folder
+  end
+
+  def write_idea(folder, created_at: "2026-05-22T12:00:00Z", original_text: "Original idea")
+    File.write(
+      File.join(folder, "idea.md"),
+      "---\ncreated_at: #{created_at}\noriginal_text: |\n  #{original_text}\n---\n\n# Idea\n\nBody fallback\n"
+    )
+  end
+
+  def write_log(root, slug, name, content, mtime:)
+    dir = File.join(root, ".hive-state", "logs", slug)
+    FileUtils.mkdir_p(dir)
+    path = File.join(dir, name)
+    File.write(path, content)
+    File.utime(mtime, mtime, path)
+    path
+  end
+
+  def test_inbox_loads_common_fields_and_no_extra
+    with_tmp_dir do |root|
+      folder = create_task(root, stage: "1-inbox")
+      write_idea(folder, original_text: "Keep the full source idea")
+      latest = write_log(root, "ship-info", "brainstorm-001.log", "line\n", mtime: Time.now)
+
+      info = Hive::Tui::TaskInfo.load(folder)
+
+      assert_equal "ship-info", info.slug
+      assert_equal "1-inbox", info.stage
+      assert_equal "2026-05-22T12:00:00Z", info.created_at
+      assert_equal "Keep the full source idea", info.original_text
+      assert_equal File.expand_path(folder), info.task_folder
+      assert_equal File.expand_path(latest), info.latest_log_path
+      assert_nil info.extra_label
+      assert_nil info.extra_content
+      assert info.frozen?
+    end
+  end
+
+  def test_stage_artifacts_are_loaded_for_brainstorm_and_plan
+    with_tmp_dir do |root|
+      {
+        "2-brainstorm" => [ "Brainstorm", "brainstorm.md", "# Brainstorm\n\nComplete notes\n" ],
+        "3-plan" => [ "Plan", "plan.md", "# Plan\n\nComplete plan\n" ]
+      }.each do |stage, (label, filename, content)|
+        folder = create_task(root, stage: stage, slug: "ship-#{label.downcase}")
+        write_idea(folder)
+        File.write(File.join(folder, filename), content)
+
+        info = Hive::Tui::TaskInfo.load(folder)
+
+        assert_equal label, info.extra_label
+        assert_equal content, info.extra_content
+      end
+    end
+  end
+
+  def test_idea_and_stage_artifact_reads_preserve_full_content
+    with_tmp_dir do |root|
+      idea = "idea-" + ("i" * ((256 * 1024) + 1024))
+      {
+        "2-brainstorm" => [ "brainstorm.md", "brainstorm-" + ("b" * ((256 * 1024) + 1024)) ],
+        "3-plan" => [ "plan.md", "plan-" + ("p" * ((256 * 1024) + 1024)) ]
+      }.each do |stage, (filename, artifact)|
+        folder = create_task(root, stage: stage, slug: "ship-#{stage}")
+        File.binwrite(File.join(folder, "idea.md"), idea)
+        File.binwrite(File.join(folder, filename), artifact)
+
+        info = Hive::Tui::TaskInfo.load(folder)
+
+        assert_equal Digest::SHA256.hexdigest(idea), Digest::SHA256.hexdigest(info.original_text)
+        assert_equal Digest::SHA256.hexdigest(artifact), Digest::SHA256.hexdigest(info.extra_content)
+        refute info.warnings.any? { |warning| warning.include?("truncated") }
+      end
+    end
+  end
+
+  def test_task_moving_stages_during_load_is_rejected
+    with_tmp_dir do |root|
+      folder = create_task(root, stage: "2-brainstorm")
+      write_idea(folder)
+      File.write(File.join(folder, "brainstorm.md"), "Complete notes\n")
+      destination = File.join(root, ".hive-state", "stages", "3-plan", "ship-info")
+      original = Hive::Tui::TaskInfo.method(:load_extra)
+      moving_load = lambda do |task, warnings, source_paths|
+        result = original.call(task, warnings, source_paths)
+        FileUtils.mkdir_p(File.dirname(destination))
+        FileUtils.mv(task.folder, destination)
+        result
+      end
+
+      error = with_replaced_singleton_method(Hive::Tui::TaskInfo, :load_extra, moving_load) do
+        assert_raises(Hive::Tui::TaskInfo::LoadError) do
+          Hive::Tui::TaskInfo.load(folder)
+        end
+      end
+
+      assert_match(/moved or disappeared/, error.message)
+    end
+  end
+
+  def test_execute_uses_latest_overall_log_path_but_latest_execute_tail
+    with_tmp_dir do |root|
+      folder = create_task(root, stage: "4-execute")
+      write_idea(folder)
+      old_execute = write_log(root, "ship-info", "execute-001.log", "old\n", mtime: Time.now - 30)
+      latest_execute = write_log(root, "ship-info", "execute-002.log", "one\ntwo\n", mtime: Time.now - 20)
+      latest_overall = write_log(root, "ship-info", "review-001.log", "newer\n", mtime: Time.now - 10)
+
+      info = Hive::Tui::TaskInfo.load(folder)
+
+      refute_equal old_execute, info.latest_log_path
+      assert_equal File.expand_path(latest_overall), info.latest_log_path
+      assert_equal "Execute log", info.extra_label
+      assert_equal "one\ntwo", info.extra_content
+      assert_includes info.source_paths, File.expand_path(latest_execute)
+    end
+  end
+
+  def test_missing_optional_values_remain_available_explicitly
+    with_tmp_dir do |root|
+      folder = create_task(root, stage: "2-brainstorm")
+      File.write(File.join(folder, "idea.md"), "---\nslug: ship-info\n---\n")
+
+      info = Hive::Tui::TaskInfo.load(folder)
+
+      assert_equal Hive::Tui::TaskInfo::UNAVAILABLE, info.created_at
+      assert_equal Hive::Tui::TaskInfo::UNAVAILABLE, info.original_text
+      assert_equal Hive::Tui::TaskInfo::NONE, info.latest_log_path
+      assert_equal "Brainstorm", info.extra_label
+      assert_equal Hive::Tui::TaskInfo::UNAVAILABLE, info.extra_content
+    end
+  end
+
+  def test_malformed_frontmatter_falls_back_to_markdown_body
+    with_tmp_dir do |root|
+      folder = create_task(root, stage: "1-inbox")
+      File.write(File.join(folder, "idea.md"), "---\ncreated_at: [broken\n---\n\nBody survives malformed YAML\n")
+
+      info = Hive::Tui::TaskInfo.load(folder)
+
+      assert_equal Hive::Tui::TaskInfo::UNAVAILABLE, info.created_at
+      assert_equal "\nBody survives malformed YAML\n", info.original_text
+      assert_match(/malformed idea frontmatter/, info.warnings.join(" "))
+    end
+  end
+
+  def test_invalid_task_path_becomes_a_load_error
+    error = assert_raises(Hive::Tui::TaskInfo::LoadError) do
+      Hive::Tui::TaskInfo.load("/tmp/not-a-hive-task")
+    end
+
+    assert_match(/invalid task path/, error.message)
+  end
+
+  def test_loading_is_read_only
+    with_tmp_dir do |root|
+      folder = create_task(root, stage: "3-plan")
+      write_idea(folder)
+      File.write(File.join(folder, "plan.md"), "Plan stays unchanged\n")
+      before = Dir.glob(File.join(root, "**", "*"), File::FNM_DOTMATCH)
+        .select { |path| File.file?(path) }
+        .to_h { |path| [ path, [ File.binread(path), File.mtime(path) ] ] }
+
+      Hive::Tui::TaskInfo.load(folder)
+
+      after = Dir.glob(File.join(root, "**", "*"), File::FNM_DOTMATCH)
+        .select { |path| File.file?(path) }
+        .to_h { |path| [ path, [ File.binread(path), File.mtime(path) ] ] }
+      assert_equal before, after
+    end
+  end
+end
diff --git a/test/unit/tui/update_test.rb b/test/unit/tui/update_test.rb
index 53fc23ab..bef1dd75 100644
--- a/test/unit/tui/update_test.rb
+++ b/test/unit/tui/update_test.rb
@@ -152,6 +152,95 @@ class HiveTuiUpdateTest < Minitest::Test
                  new_model.red_status_detail_state.agent_label
   end
 
+  def test_task_info_open_load_and_stale_result_protection
+    row = red_detail_row
+    loading, = Hive::Tui::Update.apply(
+      model,
+      Hive::Tui::Messages::OpenTaskInfo.new(row: row, request_id: "request-1")
+    )
+    assert_equal :task_info, loading.mode
+    assert_equal :loading, loading.task_info_state.status
+
+    stale, = Hive::Tui::Update.apply(
+      loading,
+      Hive::Tui::Messages::TaskInfoLoaded.new(request_id: "older", info: Object.new)
+    )
+    assert_same loading, stale
+
+    info = Object.new
+    loaded, = Hive::Tui::Update.apply(
+      loading,
+      Hive::Tui::Messages::TaskInfoLoaded.new(request_id: "request-1", info: info)
+    )
+    assert_equal :loaded, loaded.task_info_state.status
+    assert_same info, loaded.task_info_state.info
+  end
+
+  def test_task_info_failure_and_result_after_close_are_safe
+    row = red_detail_row
+    loading, = Hive::Tui::Update.apply(
+      model,
+      Hive::Tui::Messages::OpenTaskInfo.new(row: row, request_id: "request-1")
+    )
+    failed, = Hive::Tui::Update.apply(
+      loading,
+      Hive::Tui::Messages::TaskInfoFailed.new(request_id: "request-1", error: "gone")
+    )
+    assert_equal :failed, failed.task_info_state.status
+    assert_equal "gone", failed.task_info_state.error
+
+    closed, = Hive::Tui::Update.apply(failed, Hive::Tui::Messages::BACK)
+    late, = Hive::Tui::Update.apply(
+      closed,
+      Hive::Tui::Messages::TaskInfoLoaded.new(request_id: "request-1", info: Object.new)
+    )
+    assert_same closed, late
+    assert_nil late.task_info_state
+  end
+
+  def test_back_from_task_info_restores_selected_row_after_reordering
+    selected = red_detail_row
+    other = selected.with(slug: "other-task", folder: "/tmp/other-task")
+    state = Hive::Tui::Model::TaskInfoState.new(row: selected, request_id: "request-1")
+    starting = model.with(
+      mode: :task_info,
+      task_info_state: state,
+      snapshot: snapshot_with_rows(selected, other),
+      cursor: [ 0, 0 ],
+      scope: 0,
+      pane_focus: :right
+    )
+    refreshed, = Hive::Tui::Update.apply(
+      starting,
+      Hive::Tui::Messages::SnapshotArrived.new(snapshot: snapshot_with_rows(other, selected))
+    )
+
+    closed, = Hive::Tui::Update.apply(refreshed, Hive::Tui::Messages::BACK)
+
+    assert_equal :grid, closed.mode
+    assert_nil closed.task_info_state
+    assert_equal [ 0, 1 ], closed.cursor
+    assert_equal 0, closed.scope
+    assert_equal :right, closed.pane_focus
+  end
+
+  def test_back_from_task_info_reclamps_when_selected_row_disappeared
+    selected = red_detail_row
+    other = selected.with(slug: "other-task", folder: "/tmp/other-task")
+    state = Hive::Tui::Model::TaskInfoState.new(row: selected, request_id: "request-1")
+    starting = model.with(
+      mode: :task_info,
+      task_info_state: state,
+      snapshot: snapshot_with_rows(other),
+      cursor: [ 0, 5 ]
+    )
+
+    closed, = Hive::Tui::Update.apply(starting, Hive::Tui::Messages::BACK)
+
+    assert_equal :grid, closed.mode
+    assert_equal [ 0, 0 ], closed.cursor
+  end
+
   def test_red_status_detail_scroll_down_reduces_offset
     state = Hive::Tui::Model::RedStatusDetailState.new(
       row: red_detail_row,
@@ -1338,33 +1427,6 @@ class HiveTuiUpdateTest < Minitest::Test
     assert_equal :grid, new_model.mode
   end
 
-  def test_back_from_idea_preview_clears_text_and_returns_to_grid
-    starting = model.with(
-      mode: :idea_preview,
-      idea_preview_text: "original idea",
-      idea_preview_slug: "some-slug"
-    )
-    new_model, _cmd = Hive::Tui::Update.apply(starting, Hive::Tui::Messages::BACK)
-
-    assert_equal :grid, new_model.mode
-    assert_nil new_model.idea_preview_text
-    assert_nil new_model.idea_preview_slug
-  end
-
-  def test_back_from_idea_preview_preserves_cursor_and_scope
-    starting = model.with(
-      mode: :idea_preview,
-      idea_preview_text: "original idea",
-      idea_preview_slug: "some-slug",
-      cursor: [ 1, 2 ],
-      scope: 2
-    )
-    new_model, _cmd = Hive::Tui::Update.apply(starting, Hive::Tui::Messages::BACK)
-
-    assert_equal [ 1, 2 ], new_model.cursor
-    assert_equal 2, new_model.scope
-  end
-
   def test_project_scope_sets_scope_and_resets_cursor
     starting = model.with(snapshot: snap_with_two_projects_three_rows_each, cursor: [ 0, 2 ])
     new_model, _cmd = Hive::Tui::Update.apply(starting, Hive::Tui::Messages::ProjectScope.new(n: 2))
diff --git a/test/unit/tui/views/task_info_test.rb b/test/unit/tui/views/task_info_test.rb
new file mode 100644
index 00000000..642de65c
--- /dev/null
+++ b/test/unit/tui/views/task_info_test.rb
@@ -0,0 +1,137 @@
+require "test_helper"
+require "hive/tui/model"
+require "hive/tui/task_info"
+require "hive/tui/views/task_info"
+
+class HiveTuiViewsTaskInfoTest < Minitest::Test
+  include HiveTestHelper
+
+  def info(extra_label: "Brainstorm", extra_content: "# Notes\nComplete artifact")
+    Hive::Tui::TaskInfo::Snapshot.new(
+      slug: "ship-info",
+      stage: "2-brainstorm",
+      created_at: "2026-05-22T12:00:00Z",
+      original_text: "Full original idea",
+      task_folder: "/tmp/project/.hive-state/stages/2-brainstorm/ship-info",
+      latest_log_path: "/tmp/project/.hive-state/logs/ship-info/brainstorm-001.log",
+      extra_label: extra_label,
+      extra_content: extra_content,
+      warnings: [],
+      source_paths: []
+    )
+  end
+
+  def model_for(status: :loaded, loaded_info: info, error: nil, cols: 100, rows: 24)
+    state = Hive::Tui::Model::TaskInfoState.new(
+      row: Object.new,
+      request_id: "request-1",
+      status: status,
+      info: loaded_info,
+      error: error
+    )
+    Hive::Tui::Model.initial(cols: cols, rows: rows).with(mode: :task_info, task_info_state: state)
+  end
+
+  def test_renders_full_common_and_stage_specific_content
+    out = Hive::Tui::Views::TaskInfo.render(model_for)
+
+    assert_includes out, "Task info"
+    assert_includes out, "Slug: ship-info"
+    assert_includes out, "Stage: 2-brainstorm"
+    assert_includes out, "Created: 2026-05-22T12:00:00Z"
+    assert_includes out, "Task folder: /tmp/project/"
+    assert_includes out, "Latest log: /tmp/project/"
+    assert_includes out, "Original idea"
+    assert_includes out, "Full original idea"
+    assert_includes out, "Brainstorm"
+    assert_includes out, "Complete artifact"
+    assert out.end_with?(Hive::Tui::Views::TaskInfo::CLOSE_HINT)
+  end
+
+  def test_omits_stage_section_when_snapshot_has_none
+    out = Hive::Tui::Views::TaskInfo.render(model_for(loaded_info: info(extra_label: nil, extra_content: nil)))
+
+    refute_includes out, "Brainstorm"
+    assert_includes out, "Original idea"
+  end
+
+  def test_loading_and_failure_states_keep_close_hint
+    loading = Hive::Tui::Views::TaskInfo.render(model_for(status: :loading, loaded_info: nil))
+    failed = Hive::Tui::Views::TaskInfo.render(
+      model_for(status: :failed, loaded_info: nil, error: "ENOENT: gone")
+    )
+
+    assert_includes loading, "Loading task info…"
+    refute_includes loading, "false"
+    assert_includes loading, Hive::Tui::Views::TaskInfo::CLOSE_HINT
+    assert_includes failed, "Could not load task info"
+    assert_includes failed, "ENOENT: gone"
+    assert_includes failed, Hive::Tui::Views::TaskInfo::CLOSE_HINT
+  end
+
+  def test_long_content_is_bounded_and_visibly_truncated
+    long = (1..40).map { |number| "artifact line #{number}" }.join("\n")
+    model = model_for(loaded_info: info(extra_content: long), cols: 40, rows: 10)
+
+    lines = Hive::Tui::Views::TaskInfo.render(model).lines(chomp: true)
+
+    assert_operator lines.length, :<=, 10
+    assert lines.all? { |line| line.length <= 39 }, lines.inspect
+    assert lines.any? { |line| line.include?("…") }, "truncated panel must show an ellipsis"
+    assert_equal Hive::Tui::Views::TaskInfo::CLOSE_HINT, lines.last
+  end
+
+  def test_wide_characters_wrap_by_terminal_display_cells
+    wide = ("界🧠" * 80) + "\ntrailing content"
+    model = model_for(loaded_info: info(extra_content: wide), cols: 20, rows: 10)
+
+    lines = Hive::Tui::Views::TaskInfo.render(model).lines(chomp: true)
+
+    assert_operator lines.length, :<=, 10
+    assert lines.all? { |line| Lipgloss.width(line) <= 19 },
+      "every logical row must fit physically without terminal wrapping: #{lines.inspect}"
+    assert_equal Hive::Tui::Views::TaskInfo::CLOSE_HINT, lines.last
+  end
+
+  def test_file_text_is_sanitized_without_flattening_markdown_lines
+    unsafe = "heading\e[2J\nbody\u0000tail".b
+    unsafe << "\ninvalid-\xff-byte".b
+    out = Hive::Tui::Views::TaskInfo.render(model_for(loaded_info: info(extra_content: unsafe)))
+
+    refute_includes out, "\e"
+    refute_includes out, "\u0000"
+    assert_includes out, "heading"
+    assert_includes out, "body?tail"
+    assert_includes out, "invalid-?-byte"
+  end
+
+  def test_render_only_sanitizes_rows_that_fit_the_terminal_budget
+    long = (1..10_000).map { |number| "artifact line #{number}" }.join("\n")
+    calls = 0
+    sanitizer = lambda do |text|
+      calls += 1
+      Hive::Tui::Text.sanitize(text)
+    end
+
+    with_replaced_singleton_method(Hive::Tui::Views::TaskInfo, :safe, sanitizer) do
+      Hive::Tui::Views::TaskInfo.render(model_for(loaded_info: info(extra_content: long), cols: 40, rows: 10))
+    end
+
+    assert_operator calls, :<, 100,
+      "rendering a short panel must not sanitize and wrap the complete artifact on every frame"
+  end
+
+  def test_overflow_ellipsis_is_applied_before_line_styling
+    style = Object.new
+    style.define_singleton_method(:render) { |text| "\e[1m#{text}\e[0m" }
+    line_class = Hive::Tui::Views::TaskInfo::Line
+    header = line_class.new(text: "abcdef", style: style)
+    overflow = line_class.new(text: "more", style: nil)
+
+    visible = Hive::Tui::Views::TaskInfo.fit_content([ header, overflow ], 4, 1)
+
+    assert_equal "abc…", visible.first.text
+    assert_same style, visible.first.style
+    assert_equal "\e[1mabc…\e[0m", Hive::Tui::Views::TaskInfo.render_line(visible.first)
+  end
+end
